{% extends "base_editor.html" %}
{% load static %}
{% load widget_tweaks %}

{% block nav %}
{% include "parts/nav.html" with active_tab="manage_project" %}
{% endblock %}

{% block title %}Manage project {% endblock %}

{% block jumbotron %}
<h1>Manage project</h1>
<p>Add, update or delete project.</p>
{% endblock %}

{% block content %}
<form id="project-list" method="post" action={% url "metabaseEditor:load_project" %} onchange="this.submit()">
  {% csrf_token %}
  <div class="form-group row">
    <label class="col-sm-2 col-form-label" for="{{ update_form.project.id_for_label }}">Project</label>
    <div class="col-sm-8">
      {% render_field update_form.project class="form-control" id="selectProject"%}
    </div>
    {% if perms.metabaseEditor.delete_project %}
      <button id="show-modal-delete-project" type="button" class="btn btn-danger btn-sm" data-toggle="modal" data-target="#deleteProjectModal" {% if not project %}disabled {%endif%}>Delete project</button>
    {%endif%}
  </div>
</form>
<nav>
  <div class="nav nav-tabs" id="nav-tab" role="tablist">
    <a class="nav-item nav-link {% if active_tab == 'project-information' %}active{% endif %}" id="nav-project-info-tab" data-toggle="tab" href="#project-information" role="tab" aria-controls="project-information" aria-selected="true">Project informations</a>
    <a class="nav-item nav-link {% if active_tab == 'experiment' %}active{% endif %} {%if not project or parentProject is True%}disabled{%endif%}" id="nav-experiment-tab" data-toggle="tab" href="#experiment" role="tab" aria-controls="experiment" aria-selected="false">Experiment</a>
    <a class="nav-item nav-link {% if active_tab == 'sequencing' %}active{% endif %} {%if not project or parentProject is True%}disabled{%endif%}" id="nav-sequencing-tab" data-toggle="tab" href="#sequencing" role="tab" aria-controls="sequencing" aria-selected="false">Sequencing</a>
  </div>
</nav>
<div class="tab-content" id="nav-tabContent">
  <div class="tab-pane fade {% if active_tab == 'project-information' %}show active{% endif %}" id="project-information" role="tabpanel" aria-labelledby="nav-project-info-tab">
    {{ projectInformation_form.media }}
    {% with WIDGET_ERROR_CLASS="is-invalid" %}
    <form id="form-update" method="post" action={%if not project%}{% url "metabaseEditor:create_project" %} {%else%}{% url "metabaseEditor:update_project_information" project%}{%endif%}>
      {% csrf_token %}
      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="{{ projectInformation_form.name.id_for_label }}">Name</label>
        <div class="col-sm-10">
          {% render_field projectInformation_form.name class="form-control"%}
          {%if projectInformation_form.name.errors%}
            {%for error in projectInformation_form.name.errors%}
              <div class="invalid-feedback">{{ error }}</div>
            {%endfor%}
          {%endif%}
        </div>
      </div>

      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="{{ projectInformation_form.description.id_for_label }}">Description</label>
        <div class="col-sm-10">
          {% render_field projectInformation_form.description class="form-control" %}
          {%if projectInformation_form.description.errors%}
            {%for error in projectInformation_form.description.errors%}
              <div class="invalid-feedback">{{ error }}</div>
            {%endfor%}
          {%endif%}
        </div>
      </div>

      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="{{ projectInformation_form.available.id_for_label }}">Available</label>
        <div class="col-sm-10">
          {% render_field projectInformation_form.available|set_data:"toggle:toggle"|set_data:"onstyle:success"|set_data:"offstyle:warning"|set_data:"on:yes"|set_data:"off:No" class="form-control"%}
        </div>
      </div>

      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="{{ projectInformation_form.email.id_for_label }}">Email</label>
        <div class="col-sm-10">
          {% render_field projectInformation_form.email class="form-control"%}
          {%if projectInformation_form.email.errors%}
            {%for error in projectInformation_form.email.errors%}
              <div class="invalid-feedback">{{ error }}</div>
            {%endfor%}
          {%endif%}
        </div>
      </div>

      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="{{ updatedProject_form.leader.id_for_label }}">Leader</label>
        <div class="col-sm-10">
          {% render_field projectInformation_form.leader class="form-control"%}
          {%if projectInformation_form.leader.errors%}
            {%for error in projectInformation_form.leader.errors%}
              <div class="invalid-feedback">{{ error }}</div>
              {%endfor%}
          {%endif%}
        </div>
      </div>

      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="{{ projectInformation_form.parentProject.id_for_label }}">Parent project</label>
        <div class="col-sm-5">
          <table id="parentProject-table" class="table table-striped table-bordered table-sm table-hover" width="100%" cellspacing="0">
            <thead>
              <tr>
                <th class="text-center"><input type="checkbox" id="select_all_parentProject"></th>
                <th>Project Name</th>
              </tr>
            </thead>
            <tbody>
              {% for pk, choice in projectInformation_form.parentProject.field.choices %}
              <tr>
                <td class="text-center">
                  <input type="checkbox" name="parentProject" id="id_parentProject_{{ pk }}" value="{{ pk }}" {% for parentProject in projectInformation_form.parentProject.initial %}{% if parentProject.id == pk %} checked {% endif %}{% endfor %} {% if pk == request.parentProject.id %}readonly onclick="return false"{% endif %}>
                </td>
                <td>{{ choice }}</td>
              </tr>
              {%endfor%}
            </tbody>
          </table>
        </div>
        <div class="col-sm-5 my-auto row">
          <label class="col-sm-2 col-form-label">Search: </label>
          <div class="col-sm-7 my-auto">
            <input class="form-control form-control-sm" type="text" id="search_datatables">
          </div>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="{{ projectInformation_form.users.id_for_label }}">Users</label>
        <div class="col-sm-5">
          <table id="users-table" class="table table-striped table-bordered table-sm table-hover" width="100%" cellspacing="0">
            <thead>
              <tr>
                <th class="text-center"><input type="checkbox" id="select_all_user"></th>
                <th>Name</th>
              </tr>
            </thead>
            <tbody>
              {% for pk, choice in projectInformation_form.users.field.choices %}
              <tr>
                <td class="text-center">
                  <input type="checkbox" name="users" id="id_users_{{ pk }}" value="{{ pk }}" {% for user in projectInformation_form.users.initial %}{% if user.id == pk %} checked {% endif %}{% endfor %} {% if pk == request.user.id %}readonly onclick="return false"{% endif %}>
                </td>
                <td>{{ choice }}</td>
              </tr>
              {%endfor%}
            </tbody>
          </table>
          {%if projectInformation_form.users.errors%}
            {%for error in projectInformation_form.users.errors%}
              <div class="invalid-feedback">{{ error }}</div>
            {%endfor%}
          {%endif%}
        </div>
        <div class="col-sm-3 my-auto">
          <button type="button" id="reset_modification" class="btn btn-secondary btn-sm">Reset modification</button>
        </div>
      </div>
      <div class="form-group row">
        <div class="col-sm-12 text-right">
          {%if projectInformation_form.name.value%}
            <button type="submit" class="btn btn-success">Update</button>
          {%else%}
            <button type="submit" class="btn btn-success">Create</button>
          {%endif%}
        </div>
      </div>
    </form>
    {% endwith %}
  </div>
  <div class="tab-pane fade {% if active_tab == 'experiment' %}show active{% endif %}" id="experiment" role="tabpanel" aria-labelledby="nav-experiment-tab">
    <div class="container-fluid">
      <button id="show-modal-add-experiment" type="button" class="btn btn-success btn-sm" data-toggle="modal" data-target="#checkExperimentModal">Add experiment</button>
      <button id="show-modal-delete-experiment" type="button" class="btn btn-danger btn-sm" data-toggle="modal" data-target="#deleteExperimentModal" disabled>Delete experiment</button>
      <button id="download-experiment" class="btn btn-secondary btn-sm" disabled>Download <i class="fa fa-download"></i></button>
    </div>
    <table id="experiment-table" class="table table-striped table-bordered" width="100%" cellspacing="0">
      <thead>
        <tr>
          <th nowrap>File name</th>
          <th nowrap>Submission date</th>
          <th>Tubes</th>
        </tr>
      </thead>
    </table>
  </div>
  <div class="tab-pane fade {% if active_tab == 'sequencing' %}show active{% endif %}" id="sequencing" role="tabpanel" aria-labelledby="nav-sequencing-tab">
    <div class="container-fluid">
      <button id="show-modal-add-library" type="button" class="btn btn-success btn-sm" data-toggle="modal" data-target="#addLibraryModal">Add library</button>
      <button id="show-modal-delete-sequencing" type="button" class="btn btn-danger btn-sm" data-toggle="modal" data-target="#deleteLibraryModal" disabled>Delete library</button>
    </div>
    <table id="project-sequencing-table" class="table table-striped table-bordered" width="100%" cellspacing="0">
      <thead>
        <tr>
          <th nowrap>Library name</th>
          <th nowrap>Tube name</th>
          <th>Experiment</th>
          <th nowrap>File name</th>
        </tr>
      </thead>
    </table>
  </div>
</div>
<div class="modal fade" id="checkExperimentModal" tabindex="-1" role="dialog" aria-labelledby="checkExperimentModal" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Add new experiment</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body" id="check-experiment-modal-body">
        <form id="addExperimentForm" method="POST" action="" enctype="multipart/form-data">
          {% csrf_token %}
          <div class="form-group row">
            <label class="col-md-2 col-form-label text-nowrap align-self-center" for="{{ experiment_form.excelFilePaths.id_for_label }}">Excel file</label>
            <div class="col-md-7">
              {% render_field experiment_form.excelFilePaths id="excelFilePaths" class="form-control-file form-control" autocomplete="off"%}
              <div class="invalid-feedback" id="check-experiment-modal-error">
              </div>
            </div>
            <div class="col-md-3 align-self-center text-center">
              <button id="check-experiment" type="button" form="addExperimentForm" class="btn btn-success" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Check">Check</button>
            </div>
          </div>
        </form>
        <div id="check_progress_div" class="progress" hidden=true>
        </div>
        <div id="import_progress_div" hidden=true>
        </div>
        <div id="checking-message">
          {%include "parts/checking-message.html" %}
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        <button id="import-experiment" type="submit" form="addExperimentForm" class="btn btn-success" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Import" disabled>Import</button>
        <button id="ok-modal-import" type="button" class="btn btn-success" data-dismiss="modal" hidden=true
        >Ok</button>
      </div>
    </div>
  </div>
</div>
<div class="modal fade" id="addLibraryModal" tabindex="-1" role="dialog" aria-labelledby="addLibraryModal" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Add sequencing libraries</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body" id="add-library-modal-body">
        {%include "parts/sequencing_modal.html"%}
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        <button id="add-library" class="btn btn-success" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Add">Add</button>
      </div>
    </div>
  </div>
</div>
<div class="modal fade" id="deleteExperimentModal" tabindex="-1" role="dialog" aria-labelledby="deleteExperimentModal" aria-hidden="true">
  <div class="modal-dialog modal-lg modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Remove experiment</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body" id="experiment-modal-body">
        <div id="delete-experiment-question">
          <p>Are you sure you want to delete this experiment file?</p>
        </div>
        <div id="del_info_progress_div" class="progress" hidden=true>
        </div>
        <div id="delete_progress_div" hidden=true>
        </div>
        <div id="delete-experiment-message">
        </div>
      </div>
      <div class="modal-footer">
        <button id="cancel-modal-delete" type="button" class="btn btn-secondary" data-dismiss="modal" disabled>Cancel</button>
        <button id="delete-experiment" type="button" class="btn btn-danger" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Delete" disabled>Delete</button>
        <button id="ok-modal-delete" type="button" class="btn btn-danger" data-dismiss="modal" hidden=true>Ok</button>
      </div>
    </div>
  </div>
</div>
<div class="modal fade" id="deleteLibraryModal" tabindex="-1" role="dialog" aria-labelledby="deleteLibraryModal" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Delete library</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body" id="sequencing-modal-body">
        <div id="delete-library-question">
          <p>Are you sure you want to delete this library?</p>
        </div>
        <div id="delete-library-message">
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        <button id="delete-library" type="button" class="btn btn-danger" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Delete">Delete</button>
      </div>
    </div>
  </div>
</div>
<div class="modal fade" id="deleteProjectModal" tabindex="-1" role="dialog" aria-labelledby="deleteProjectModal" aria-hidden="true" data-keyboard="false" data-backdrop="static">
  <div class="modal-dialog modal-lg modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Remove project</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body" id="project-modal-body">
        <div id="delete-project-question">
          <p>Are you sure you want to delete the project?</p>
        </div>
        <div id="del-project-info-progress-div" class="progress" hidden=true>
        </div>
        <div id="delete-project-progress-div" hidden=true>
        </div>
        <div id="delete-project-message">
        </div>
      </div>
      <div class="modal-footer">
        <button id="cancel-modal-project-delete" type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        {% if parentProject is True %}
          <button id="delete-project" type="button" class="btn btn-danger del-project" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Delete with sub-project" disabled>Delete with sub-project</button>
          <button id="delete-parent-project" type="button" class="btn btn-danger del-project" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Delete only parent project" disabled>Delete only parent project</button>
        {% else %}
          <button id="delete-project" type="button" class="btn btn-danger del-project" data-loading-text=" <i class='fa fa-spinner fa-spin'></i> Delete" disabled>Delete</button>
        {% endif %}
        <button id="ok-modal-project-delete" type="button" class="btn btn-danger" data-dismiss="modal" hidden=true>Ok</button>
      </div>
    </div>
  </div>
</div>

{% endblock %}
{% block script %}
  {{ block.super }}
  <script src={% static "js/manage_project.js" %}></script>
  <script src={% static "js/delete_project_modal.js" %}></script>
  <script src={% static "js/project_information_tab.js" %}></script>
  <script src={% static "js/delete_experiment_modal.js" %}></script>
  <script src={% static "js/add_experiment_modal.js" %}></script>
  <script src={% static "js/delete_library_modal.js" %}></script>
  <script src={% static "js/add_library_modal.js" %}></script>
{% endblock %}
